package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesEquipVariableCollectContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionProcessContext;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentVariableCfg;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

public interface IMesProductionProcessContextStepService {

    @ApiOperation(value = "获取生产过程上下文对象")
    MesProductionProcessContext getProductionProcessContext(StationRequestBean reqBean);

    @ApiOperation(value = "获取工序工艺信息")
    MesProductionProcessContext processContext(StationRequestBean reqBean);

    @ApiOperation(value = "获取工序工艺信息")
    MesProductionProcessContext processContext(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "验证组织模型有效性")
    MesProductionProcessContext checkBaseData(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "获取工位设备集合信息")
    MesProductionProcessContext getCellEquipmentList(StationRequestBean reqBean);

    @ApiOperation(value = "获取工位设备集合信息")
    MesProductionProcessContext getCellEquipmentList(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "获取工位当前设备信息")
    MesProductionProcessContext getCurCellEquipment(StationRequestBean reqBean);

    @ApiOperation(value = "获取工位当前设备信息")
    MesProductionProcessContext getCurCellEquipment(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "获取设备数据变量信息")
    MesProductionProcessContext getEquipmentVariable(StationRequestBean reqBean, Integer variableType, String... categoryLevelTwo);

    @ApiOperation(value = "获取设备数据变量信息")
    MesProductionProcessContext getEquipmentVariable(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext, Integer variableType, String... categoryLevelTwo);

    @ApiOperation(value = "获取设备数据变量接口逻辑信息")
    MesProductionProcessContext getEquipmentVariableCfg(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "对设备数据变量信息进行必要性验证")
    MesProductionProcessContext checkNecessaryEquipmentVariable(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext, Integer variableType, String... categoryLevelTwo);

    @ApiOperation(value = "对设备数据变量接口逻辑信息进行必要性验证")
    MesProductionProcessContext checkNecessaryEquipmentVariableCfg(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "获取设备分表采集数据")
    MesProductionProcessContext doHandleEquipmentLogListByIds(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "设备数据变量接口逻辑信息数据分组")
    Map<String, List<MesEquipmentVariableCfg>> getEquipmentVariableCfgMap(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext);

    @ApiOperation(value = "根据设备数据变量接口逻辑信息匹配结果")
    MesEquipmentVariableCfg execMatchEquipmentVariableCfgValue(StationRequestBean reqBean, MesProductionProcessContext productionProcessContext,
                                                               MesEquipVariableCollectContext collectContext, Map<String, List<MesEquipmentVariableCfg>> equipmentVariableCfgMap, Boolean isNeedVariableCfgValue);
}
