package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * 生产过程上下文对象-设备数据变量平铺接口逻辑与采集信息
 */
@Data
public class MesEquipVariableCollectContext {

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("设备变量ID")
    private Long equipVariableId;

    @ApiParam("设备ID")
    private Integer equipId;

    @ApiParam("OPC注册ID")
    private Integer clientHandle;

    @ApiParam("设备代码")
    private String equipmentCode;

    @ApiParam("通道")
    private String channel;

    @ApiParam("通道")
    private String device;

    @ApiParam("tag名称")
    private String tagName;

    @ApiParam("变量配置类型")
    private String variableCfgType;

    @ApiParam("变量类型")
    private Integer variableType;

    @ApiParam("二级变量")
    private String categoryLevelTwo;

    @ApiParam("是否常变值")
    private Integer needNewValue;

    @ApiParam("设备变量名称")
    private String equipVariableName;

    @ApiParam("设备变量描述")
    private String equipVariableDesc;

    @ApiParam("读写标记")
    private Integer readWriteFlag;

    @ApiParam("数据类型")
    private String dataType;

    @ApiParam("变量当前值")
    private String equipVariableValue;

    @ApiParam("设备质量")
    private Integer quality;

    public MesEquipVariableCollectContext(Long equipVariableId) {
        this.equipVariableId = equipVariableId;
    }

    public MesEquipVariableCollectContext needNewValue(Integer needNewValue) {
        this.needNewValue = needNewValue;
        return this;
    }

    public void clear() {
        this.equipVariableName = null;
        this.equipVariableDesc = null;
        this.readWriteFlag = null;
        this.dataType = null;
        this.equipVariableValue = null;
        this.quality = null;
    }
}
